
Base Distribution - Story # 44982

Status: Resolved Priority: Should have
Author: Sebastian Kurfuerst Category: Content Repository
Created: 2013-01-30 Assigned To:
Updated: 2013-03-26 Due date:
Subject: Refactor Node Type Definition according to new syntax
Description

see #44955 for the to-be-implemented node type definition

How To Review

The change is currently under review in https://review.typo3.org/#/q/topic:44982,n,z

However, the change is quite big, so that's why I created some github repositories which
show the incremental changes which were made (to make the diff more manageable):

    -  https://github.com/skurfuerst/TYPO3.Neos/commits/dev-nodetyperenaming
    -  https://github.com/skurfuerst/TYPO3.Neos.ContentTypes/commits/dev-nodetyperenaming
    -  https://github.com/skurfuerst/TYPO3.TYPO3CR/commits/dev-nodetyperenaming

    -  For each version which has been pushed to gerrit, a tag has been created named reviewX
  (e.g. review1) in all of the three repositories above

    -  After every incremental change I did, Neos was (I think) fully functional for me. So you can easily
  check out any intermediate step by just cloning the respective versions from the GitHub repository.

    -  just make sure to use the non-minified JavaScript while testing, and if necessary clear all caches.

HAPPY TESTING :-)

Next Steps

    -  There will be one more breaking change for 1.0, which renames TYPO3.Neos.ContentTypes to
TYPO3.Neos.NodeTypes. but aside from that, the node type definition should be quite stable now :-)

    -  Furthermore, the base node types will still change once again (#45317)

Related issues:
related to Base Distribution - Task # 44955: decide Node Type Definition naming Resolved
related to Base Distribution - Work Package # 44971: TYPO3 Neos API Definition Accepted 2013-06-30
related to TYPO3 Flow Base Distribution - Feature # 45164: Define syntax for ... Accepted 2013-02-05
precedes Base Distribution - Story # 45310: Implement enhanced @position synt... New 2013-02-09
precedes Base Distribution - Task # 45309: Rename TYPO3.Neos.ContentTypes pac... Resolved 2013-02-09
precedes TYPO3.TYPO3CR - Feature # 45312: add required child nodes to Node Types New 2013-02-09
precedes Base Distribution - Story # 44990: Implement Node Type Schema Valida... Resolved 2013-01-31 2013-01-31
precedes TYPO3.TYPO3CR - Feature # 45311: Add isAbstract and isMixin to NodeT... New 2013-02-09

Associated revisions
Revision 883c1dff - 2013-03-26 11:59 - Sebastian Kurfuerst

[!!!][FEATURE] Refactored node type definitions

    -  Internal use of "Content Type" is consistently renamed to "Node Type" 
    -  Node type configuration is externalized from Settings.yaml into

  NodeTypes.yaml
    -  Refactored node type schema structure
This change is breaking because it completely changes the Node Type
configuration format.

The change needs to be tested together with the related ones in the
other packages; see #44982 for detailed instructions.

Resolves: #44982
Change-Id: I6efc0a9fd9fff709fcd0be664d11e58d529a4f1f

Revision 62e0d194 - 2013-03-26 12:01 - Sebastian Kurfuerst

[!!!][FEATURE] Refactored node type definitions

    -  internal use of "Content Type" is consistently renamed to "Node Type" 
    -  node type configuration is externalized from Settings.yaml into

  NodeTypes.yaml
    -  refactored node type schema structure

This change is breaking because it completely changes the Node Type
configuration format.
Furthermore it is breaking because a database migration needs to be
executed.

The change needs to be tested together with the related ones in the
other packages; see #44982 for detailed instructions.

Resolves: #44982
Change-Id: Ibabc5e1f5ff468eb5c444b431c9a3bff48c96cd5

Revision 1e53dd9e - 2013-03-26 13:04 - Sebastian Kurfuerst

[!!!][FEATURE] Refactored node type definitions

    -  internal use of "Content Type" is consistently renamed to "Node Type" 
    -  node type configuration is externalized from Settings.yaml into

  NodeTypes.yaml
    -  refactored node type schema structure

This change is breaking because it completely changes the Node Type
configuration format.

The change needs to be tested together with the related ones in the
other packages; see #44982 for detailed instructions.

Resolves: #44982
Change-Id: I02911d364c3b69085562b3d271655cc584b48cfc

Revision 7098db00 - 2013-03-26 15:07 - Robert Lemke 

[!!!][TASK] Rename package to TYPO3.Neos.NodeTypes
This renames the package from ContentTypes to NodeTypes,
including all node types defined within. Please execute the
node type migration script in order to migrate existing content
of your website.

Change-Id: I061d22a2c95d5265e045b10a22b40aa5d59d3e23
Related: #44982

Revision dbee0b5f - 2013-03-26 23:06 - Robert Lemke 

[!!!][TASK] Adjusted to renamed TYPO3.Neos.ContentTypes package

See https://review.typo3.org/19292 for more information.

Change-Id: Iec2a84ec2a419bbd256c96c436e055c3dc4cad47
Related: #44982

Revision 99f05285 - 2013-03-27 10:38 - Karsten Dambekalns

[TASK] Adjusted to renamed TYPO3.Neos.ContentTypes package

See https://review.typo3.org/19292 for more information.

Change-Id: Ia1586b58f5926b540c9d9d7eeba3669e7ce0bbb2
Related: #44982

History
#1 - 2013-01-30 16:38 - Sebastian Kurfuerst
- Category set to Content Repository
- Target version set to 1.0 beta 1

#2 - 2013-01-30 18:48 - Sebastian Kurfuerst

The following TODOs still remain:

    -  [MUST HAVE FOR 1.0] rename TYPO3.Neos.ContentTypes to TYPO3.Neos.NodeTypes (#45309)
    -  [MUST HAVE FOR 1.0] document the new syntax (#44971)
    -  [OPTIONAL] implement enhanced @position syntax (#45310)
    -  [OPTIONAL] add isAbstract and isMixin to node type schema (#45311)
    -  [OPTIONAL] add required child nodes to node types (#45312)
    -  [VERY NICE TO HAVE] make it validatable (#44990)

#3 - 2013-02-09 11:14 - Sebastian Kurfuerst
- Status changed from New to Accepted

#4 - 2013-02-09 11:15 - Sebastian Kurfuerst

_________CURRENT STATE_________
DONEDONE - superTypes DONE
DONEDONE - ui
  - label DONE
  - darkIcon DONE
  - icon DONE
  - inlineEditable DONE (was before: !showUneditableOverlay)
  - group DONE
  - inspector:
     groups:
         - label (DONE)
        - position (DONE, TODO extended syntax)

DONEDONE - childNodes.X DONE
    - type DONE
DONEDONE - properties.X DONE
    - type DONE
    - defaultValue DONE
    - ui
      - label DONE
      - reloadIfChanged (DONE, was reloadOnChange before)
      - inlineEditable DONE
      - inspector
              - group DONE
            - position DONE, TODO extended syntax
            - editor DONE
            - editorOptions DONE

_________TARGET________________

- superTypes DONE
- childNodes.X
    - type DONE
    - autoCreated: true
    - mandatory: true (or "required"?)
- isAbstract (#45311)
- isMixin (#45311)
- properties.X DONE
    - type DONE
    - defaultValue DONE
    - ui
        - label DONE
        - reloadIfChanged DONE
        - inlineEditable DONE
        - inspector
            - group DONE
            - position DONE, TODO extended syntax
            - editor DONE
            - editorOptions DONE
- ui
    - label DONE
    - icon DONE
    - darkIcon DONE
    - group DONE
    - inlineEditable DONE
    - inspector
        - groups.X
            - label DONE
            - position DONE (TODO: extended syntax)

____________before_____________

- superTypes
- label
- icon
- darkIcon
- group
- showUneditableOverlay
- inlineEditableProperties
- structure.X
    - type
- groups
    - label
    - priority
. properties.X
    - type
    - label
    - default
    - group
    - priority
    - reloadOnChange
    - options
    - userInterface
        - class

#5 - 2013-02-09 11:22 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18147

#6 - 2013-02-09 11:27 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18148

#7 - 2013-02-09 11:30 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18150

#8 - 2013-02-09 15:06 - Gerrit Code Review
Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18147

#9 - 2013-02-09 17:05 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18150

#10 - 2013-02-09 17:21 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18147

#11 - 2013-02-09 18:01 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18150

#12 - 2013-02-09 18:43 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18150

#13 - 2013-02-09 18:44 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18148

#14 - 2013-02-09 19:49 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18148

#15 - 2013-02-09 19:51 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18164

#16 - 2013-02-18 18:44 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18148

#17 - 2013-02-27 14:18 - Gerrit Code Review
Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18147

#18 - 2013-02-27 15:00 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18148

#19 - 2013-02-27 15:15 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18147

#20 - 2013-02-27 15:16 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18147

#21 - 2013-03-02 18:18 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18147

#22 - 2013-03-02 18:23 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18150

#23 - 2013-03-06 19:45 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18150

#24 - 2013-03-06 20:04 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18148

#25 - 2013-03-11 00:19 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18148

#26 - 2013-03-11 15:31 - Gerrit Code Review
Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18148

#27 - 2013-03-11 15:58 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18148

#28 - 2013-03-11 17:12 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18150

#29 - 2013-03-11 17:12 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18148

#30 - 2013-03-13 13:29 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18150

#31 - 2013-03-13 14:00 - Gerrit Code Review

Patch set 11 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18148

#32 - 2013-03-25 14:56 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18148

#33 - 2013-03-25 15:00 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18150

#34 - 2013-03-25 15:09 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18147

#35 - 2013-03-25 18:21 - Gerrit Code Review
Patch set 9 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18147

#36 - 2013-03-26 10:02 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18147

#37 - 2013-03-26 11:58 - Gerrit Code Review

Patch set 13 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18148

#38 - 2013-03-26 11:59 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18150

#39 - 2013-03-26 12:01 - Gerrit Code Review

Patch set 11 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18147

#40 - 2013-03-26 12:37 - Sebastian Kurfuerst
- Status changed from Accepted to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:883c1dfff2e590e40904bad3d140d3679ab0a24f.

#41 - 2013-03-26 13:04 - Gerrit Code Review

Patch set 14 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18148
